/**
   This program reads in the dimensions of a box and then constructs
   a Box3 object that encapsulates the data for the box.

   Since the data fields of an object are private, this program
   uses "accessor methods" (i.e., get and set methods) to
   manipulate data from the object.

   This program computes the "length plus girth" of a box (a
   measurement used by shipping companies).

   This program makes use of the fact that Box2 objects know
   how to compute their own volume, and they also know how to
   create a printable description of themselves.
*/
import java.util.Scanner;

public class UseBox3
{
   public static void main(String[] args)
   {
      Scanner sc = new Scanner(System.in);

      Box3 box;  // declare a variable of type Box3

      // get data from the keyboard operator
      System.out.println("Please enter the dimensions of the box.");
      System.out.print("Please enter the height: ");
      double height = sc.nextDouble();
      System.out.print("Please enter the width: ");
      double width = sc.nextDouble();
      System.out.print("Please enter the length: ");
      double length = sc.nextDouble();

      // create a Box3 object with the appropriate
      // dimensions (using a constructor)  and name it box
      box = new Box3(height, width, length);

      // make use of the data in the Box object
      System.out.println( box );
      System.out.println("The volume of the box is " + box.volume() + ".");
      System.out.println("The length plus girth of the box is " + lengthPlusGirth(box) + ".");

   }//main()


   static double lengthPlusGirth(Box3 box)
   {
       // the "length" should be the largest
       // dimension of the box
       if (box.getWidth() > box.getLength())
       {
          // if width is larger than length
          // then swap the two values
          // (notice that we are manipulating
          // the data in the Box2 object)
          double temp = box.getLength();
          box.setLength( box.getWidth() );
          box.setWidth( temp );
       }
       if (box.getHeight() > box.getLength())
       {
          // if height is larger than length
          // then swap the two values
          double temp = box.getLength();
          box.setLength( box.getHeight() );
          box.setHeight( temp );
       }
       return box.getLength() + 2*box.getWidth() + 2*box.getHeight();
   }//lengthPlusGirth()

}//UseBox3
